$CHIP(65C02)
;  TEST6502.ASM - TEST THE 6500 DISASSEMBLER
;
;  6-feb-94 BY JOHN HARTMAN
;
N1	EQU	12H
N2	EQU	1234H
;
	DEFSEG	TESTCODE, CLASS=CODE
	SEG	TESTCODE

        BRK        		;00
LL:     ORA        (N1,X)	;01
        DB	   02H		;02
	DB	   03H		;03
        TSB	   N1		;04
        ORA        N1           ;05
        ASL        N1           ;06
        RMB0	   N1		;07
        PHP        		;08
        ORA        #N1      	;09
        ASL        A      	;0A
        DB	   0BH		;0B
        TSB        N2           ;0C
        ORA        N2        	;0D
        ASL        N2        	;0E
        BBR0	   N1,LL      	;0F

        BPL        LL     	;10
        ORA        (N1),Y   	;11
        ORA        (N1)   	;12
        DB	   13H		;13
        TRB        N1     	;14
        ORA        N1,X     	;15
        ASL        N1,X     	;16
        RMB1	   N1		;17
        CLC        		;18
        ORA        N2,Y   	;19
        INC        A      	;1A
        DB	   1BH		;1B
        TRB        N2           ;1C
        ORA        N2,X         ;1D
        ASL        N2,X		;1E
        BBR1       N1,LL      	;1F

        JSR        LL    	;20
        AND        (N1,X)   	;21
        DB         22H		;22
        DB         23H     	;23
        BIT        N1      	;24
        AND        N1      	;25
        ROL        N1      	;26
        RMB2	   N1		;27
        PLP        		;28
        AND        #N1      	;29
        ROL        A      	;2A
        DB	   2BH          ;2B
        BIT        N2        	;2C
        AND        N2        	;2D
        ROL        N2        	;2E
        BBR2	   N1,LL	;2F

        BMI        LL     	;30
        AND        (N1),Y   	;31
        AND        (N1)   	;32
        DB	   33H		;33
        BIT        N1,X     	;34
        AND        N1,X     	;35
        ROL        N1,X     	;36
        RMB3	   N1		;37
        SEC        		;38
        AND        N2,Y         ;39
        DEC        A    	;3A
        DB         3BH          ;3B
        BIT        N2,X		;3C
        AND        N2,X      	;3D
        ROL        N2,X        	;3E
        BBR3	   N1,LL	;3F

LL2:    RTI        		;40
        EOR        (N1,X)   	;41
        DB 	   42H		;42
        DB 	   43H 		;42
        DB 	   44H		;42
        EOR        N1      	;45
        LSR        N1      	;46
        RMB4	   N1		;47
        PHA        		;48
        EOR        #N1      	;49
        LSR        A      	;4A
        DB         4BH          ;4B
        JMP        LL2		;4C
        EOR        N2        	;4D
        LSR        N2        	;4E
        BBR4       N1,LL2	;4F

        BVC        LL2     	;50
        EOR        (N1),Y   	;51
        EOR        (N1)   	;52
        DB	   53H		;53
        DB	   54H		;54
        EOR        N1,X     	;55
        LSR        N1,X     	;56
        RMB5	   N1		;57
        CLI        		;58
        EOR        N2,Y        	;59
        PHY	   		;5A
        DB	   5BH		;5B
        DB	   5CH		;5C
        EOR        N2,X         ;5D
        LSR        N2,X         ;5E
        BBR5       N1,LL2	;5F

LL3:    RTS        		;60
        ADC        (N1,X)   	;61
        DB	   62H		;62
        DB	   63H		;63
        STZ        N1      	;64
        ADC        N1      	;65
        ROR        N1      	;66
        RMB6	   N1		;67
        PLA        		;68
        ADC        #N1      	;69
        ROR        A      	;6A
        DB         6BH    	;6B
        JMP        (N2)		;6C
        ADC        N2        	;6D
        ROR        N2        	;6E
        BBR6       N1,LL2	;6F

        BVS        LL3     	;70
        ADC        (N1),Y   	;71
        ADC        (N1)   	;72
        DB	   73H		;73
        STZ	   N1,X		;74
        ADC        N1,X     	;75
        ROR        N1,X		;76
        RMB7	   N1		;77
        SEI        		;78
        ADC        N2,Y         ;79
        PLY	   		;7A
        DB	   7BH		;7B
        JMP        (N2,X)       ;7C
        ADC        N2,X         ;7D
        ROR        N2,X         ;7E
        BBR7       N1,LL3	;7F

        BRA        LL3     	;80
        STA        (N1,X)   	;81
        DB         82H      	;82
        DB         83H      	;83
        STY        N1      	;84
        STA        N1      	;85
        STX        N1      	;86
        SMB0	   N1		;87
        DEY        		;88
        BIT	   #N1		;89
        TXA        		;8A
        DB         8BH          ;8B
        STY        N2        	;8C
        STA        N2        	;8D
        STX        N2        	;8E
LL4:    BBS0       N1,LL3	;8F

        BCC        LL4     	;90
        STA        (N1),Y   	;91
        STA        (N1)   	;92
        DB	   93H		;93
        STY        N1,X     	;94
        STA        N1,X     	;95
        STX        N1,Y     	;96
        SMB1	   N1		;97
        TYA        		;98
        STA        N2,Y	        ;99
        TXS        		;9A
        DB         9BH          ;9B
        STZ	   N2		;9C
        STA        N2,X	        ;9D
        STZ	   N2,X		;9E
        BBS1       N1,LL4	;9F

        LDY        #N1      	;A0
        LDA        (N1,X)   	;A1
        LDX        #N1      	;A2
        DB	   0A3H		;A3
        LDY        N1      	;A4
        LDA        N1      	;A5
        LDX        N1      	;A6
        SMB2	   N1		;A7
        TAY        		;A8
        LDA        #N1      	;A9
        TAX        		;AA
        DB         0ABH         ;AB
        LDY        N2        	;AC
        LDA        N2        	;AD
        LDX        N2        	;AE
        BBS2       N1,LL4	;AF

        BCS        LL4     	;B0
        LDA        (N1),Y   	;B1
        LDA        (N1)		;B2
        DB         0B3H     	;B3
        LDY        N1,X     	;B4
        LDA        N1,X     	;B5
        LDX        N1,Y     	;B6
        SMB5	   N1		;B7
        CLV        		;B8
        LDA        N2,Y	        ;B9
        TSX        		;BA
        DB         0BBH         ;BB
        LDY        N2,X         ;BC
        LDA        N2,X         ;BD
        LDX        N2,Y         ;BE
        BBS3       N1,LL4	;BF

LL5:    CPY        #N1      	;C0
        CMP        (N1,X)   	;C1
        DB         0C2H		;C2
        DB         0C3H		;C3
        CPY        N1      	;C4
        CMP        N1      	;C5
        DEC        N1      	;C6
        SMB6	   N1		;C7
        INY        		;C8
        CMP        #N1      	;C9
        DEX        		;CA
        DB         0CBH         ;CB
        CPY        N2        	;CC
        CMP        N2        	;CD
        DEC        N2        	;CE
        BBS4       N1,LL5	;CF

        BNE        LL5     	;D0
        CMP        (N1),Y   	;D1
        CMP        (N1)   	;D2
        DB	   0D3H		;D3
        DB	   0D4H		;D4
        CMP        N1,X     	;D5
        DEC        N1,X     	;D6
        SMB5	   N1		;D7
        CLD        		;D8
        CMP        N2,Y         ;D9
        PHX	   		;DA
        DB	   0DBH		;DB
        DB	   0DCH		;DC
        CMP        N2,X         ;DD
        DEC        N2,X         ;DE
        BBS5       N1,LL5	;DF

        CPX        #N1      	;E0
        SBC        (N1,X)   	;E1
        DB	   0E2H		;E2
        DB	   0E3H		;E3
        CPX        N1      	;E4
        SBC        N1      	;E5
        INC        N1      	;E6
        SMB6	   N1		;E7
        INX        		;E8
        SBC        #N1      	;E9
        NOP        		;EA
        DB         0EBH         ;EB
        CPX        N2        	;EC
        SBC        N2        	;ED
        INC        N2        	;EE
        BBS6       N1,LL5	;EF

        BEQ        LL5     	;F0
        SBC        (N1),Y   	;F1
        SBC        (N1)   	;F2
        DB	   0F3H		;F3
        DB	   0F4H		;F4
        SBC        N1,X     	;F5
        INC        N1,X     	;F6
        SMB7	   N1		;F7
        SED        		;F8
        SBC        N2,Y         ;F9
        PLX	   		;FA
        DB	   0FBH		;FB
        DB	   0FCH		;FC
        SBC        N2,X         ;FD
        INC        N2,X         ;FE
        BBS7       N1,LL5	;FF
;
	END
